import java.awt.*;
import java.awt.event.*;


public class GenePicker extends Tree
{
public GenePicker()
	{
	super();

	this.addActionListener(new ActionListener()
		{
		public void actionPerformed(ActionEvent e){ClickMe();}
		});
	}

public GenePicker(Color background)
	{
	super(background);
	this.addActionListener(new ActionListener()
		{
		public void actionPerformed(ActionEvent e){ClickMe();}
		});
	}


public GenePicker(int d,int a,int l)
	{
	super(d,a,l);
	this.addActionListener(new ActionListener()
		{
		public void actionPerformed(ActionEvent e){ClickMe();}
		});
	}

public GenePicker(int d,int a,int l,Color background)
	{
	super(d,a,l,background);
	this.addActionListener(new ActionListener()
		{
		public void actionPerformed(ActionEvent e){ClickMe();}
		});	
	}


public void ClickMe()
	{
	DialogFrame win = new DialogFrame(this,"Genome editor",depth,angle,length);

	win.show();
	}

}


class DialogFrame extends Frame
{
TextField depth,angle,length;
int dep,ang,len;
Tree t;
ActionListener actionListener;
GenePicker parent;

public Tree getTree() {return t;}

DialogFrame(GenePicker par,String title,int d,int a,int l)
	{
	super(title);
	parent = par;
	Panel buttons = new Panel();
	
	t = new Tree(d,a,l);
	resize(500,500);

	add("Center",t);
	add("South",buttons);
	buttons.setLayout(new FlowLayout());

	buttons.add(new Label("Depth"));
	depth = new TextField(""+d);
	depth.setSize(new Dimension(50,10));
	buttons.add(depth);

	buttons.add(new Label("Angle"));
	angle = new TextField(""+a);
	buttons.add(angle);

	buttons.add(new Label("Length"));
	length = new TextField(""+l);
	buttons.add(length);

	Button ok = new Button("OK");
	Button cancel = new Button("Cancel");
	Button pre = new Button("Preview Changes");

	buttons.add(ok);
	ok.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e)
				{
				String temp;
		
				dep = Integer.parseInt(temp);
				temp = angle.getText();
				ang = Integer.parseInt(temp);
				temp = length.getText();
				len = Integer.parseInt(temp);
				
				t = new Tree(dep,ang,len);
				parent.updateTree(t);
				dispose();
				}
			});

	buttons.add(pre);
	pre.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e)
				{
				String temp;
		
				temp = depth.getText();
				dep = Integer.parseInt(temp);
				temp = angle.getText();
				ang = Integer.parseInt(temp);
				temp = length.getText();
				len = Integer.parseInt(temp);
				
				doUpdateTree();
				}
			});


	buttons.add(cancel);
	cancel.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e)
				{
				dispose();
				}
			});

	}

public void doUpdateTree()
	{
	t.depth = dep;
	t.length = len;
	t.angle = ang;
	t.updateTree(t);
	}

} // end popup window
